<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>AdminLTE 3 | Blank Page</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">

  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

</head>

<body class="hold-transition sidebar-mini">
  <!-- Site wrapper -->
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>


    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Devcamp 120</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Huy</a>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="academic transcript.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v1</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1>Quản lý bảng điểm</h1>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Blank Page</li>
              </ol>
            </div>
          </div>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="text-center mt-2 mb-2">
            <h2>F200 - Lịch sử học tập</h2>
          </div>
          <div class="jumbotron container">
            <div class="row form-group mb-0">
              <div class="col-sm-5">
                <div class="row">

                  <label class="col-form-label col-sm-3">Student</label>

                  <div class="col-sm-9">
                    <select id="select-student" class="form-control">
                      <option value="0"> Student</option>
                    </select>
                  </div>
                </div>

              </div>
              <div class="col-sm-5">
                <div class="row">

                  <label class="col-form-label col-sm-3">Subject</label>

                  <div class="col-sm-9">
                    <select id="select-subject" class="form-control">
                      <option value="0"> Subject</option>
                    </select>
                  </div>
                </div>
              </div>
              <div class="col-sm-2">
                <button id="btn-filter" class="btn btn-info">Lọc dữ liệu</button>
              </div>
            </div>
          </div>

          <div class="container-fluid">
            <div class="form-group">
              <button class="btn btn-success" id="btn-add-new"><i class="fa fa-plus"></i>&nbsp; Thêm mới</button>
            </div>
            <table class="table table-bordered table-striped table-hover" id="student-table">
              <thead class="thead-dark">
                <tr>
                  <th>STT</th>
                  <th>Student</th>
                  <th>Môn học </th>
                  <th>Điểm</th>
                  <th>Ngày Thi</th>
                  <th>Action</th>
                </tr>
              </thead>
            </table>
          </div>
        </div>
        <!-- Modal Thêm mới -->
        <div id="modal-create" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h3 class="modal-title">Thêm mới</h3>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <label class="col-sm-3"> Student </label>
                  <div class="col-sm-9">
                    <select type="text" class="form-control" id="select-student-create">
                      <option value="0">Tên sinh viên</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-3"> Subject</label>
                  <div class="col-sm-9">
                    <select type="text" class="form-control" id="select-subject-create">
                      <option value="0">Môn học</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-3"> Grades</label>
                  <div class="col-sm-9">
                    <input type="text" class="form-control" id="inp-grade-create">
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-3"> examDate</label>
                  <div class="col-sm-9">
                    <input type="date" class="form-control" id="inp-examDate-create">
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button id="btn-create" class="btn btn-success">Create</button>
                <button data-dismiss="modal" class="btn btn-secondary">Cancel</button>

              </div>
            </div>
          </div>
        </div>
        <!-- Modal Update -->
        <div id="modal-update" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h3 class="modal-title">Update</h3>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <label class="col-sm-3"> Student </label>
                  <div class="col-sm-9">
                    <select type="text" class="form-control" id="select-student-update">
                      <option value="0">Tên sinh viên</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-3"> Subject</label>
                  <div class="col-sm-9">
                    <select type="text" class="form-control" id="select-subject-update">
                      <option value="0">Môn học</option>
                    </select>
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-3"> Grades</label>
                  <div class="col-sm-9">
                    <input type="text" class="form-control" id="inp-grade-update">
                  </div>
                </div>
                <div class="row form-group">
                  <label class="col-sm-3"> examDate</label>
                  <div class="col-sm-9">
                    <input type="date" class="form-control" id="inp-examDate-update">
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button id="btn-update" class="btn btn-success">Update</button>
                <button data-dismiss="modal" class="btn btn-secondary">Cancel</button>

              </div>
            </div>
          </div>
        </div>

        <!-- Modal Delete -->
        <div id="modal-delete" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h3 class="modal-title">Delete</h3>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <div class="row form-group">
                  <div class="col-sm-12">
                    <p>Bạn có muốn xóa bảng điểm không?</p>
                  </div>
                </div>
              </div>
              <div class="modal-footer">
                <button id="btn-delete" class="btn btn-danger">Delete</button>
                <button data-dismiss="modal" class="btn btn-secondary">Cancel</button>

              </div>
            </div>
          </div>
        </div>
      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <footer class="main-footer">
      <div class="float-right d-none d-sm-block">
        <b>Version</b> 3.2.0
      </div>
      <strong>Devcamp &copy; 2022-2023 <a href="https://adminlte.io">AdminLTE.io</a>.</strong> All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->

  <!-- jQuery -->
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>

  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script>
    "use strict"
    $(document).ready(function () {
      var gBASE_URL = "https://62454a477701ec8f724fb923.mockapi.io/api/v1/";
      let gID
      var gSTT = 1
      var gStudent = [];
      var gSubject = [];
      var gGrace;
      const gNameCol = ["id", "studentId", "subjectId", "grade", "examDate", "action"];
      const gSTT_COL = 0;
      const gSTUDENT_COL = 1;
      const gSUBJECTS_COL = 2;
      const gGRADE_COL = 3;
      const gDATE_COL = 4;
      const gACTION_COL = 5;
      // hàm mapping MÔN HỌC
      function mappingSubject(paramSubjetc) {
        var vSubject = ""
        for (var bI = 0; bI < gSubject.length; bI++) {
          if (paramSubjetc == gSubject[bI].id) {
            vSubject = gSubject[bI].subjectName
          }
        }
        return vSubject
      }

      // hàm mapping cho ô Student

      function mappingStudent(paramStudent) {
        var vStudent = ""
        for (var bI = 0; bI < gStudent.length; bI++) {
          if (gStudent[bI].id == paramStudent) {
            vStudent = (gStudent[bI].firstname + " " + gStudent[bI].lastname)
          }
        }
        return vStudent

      }
      var gGradeTable = $("#student-table").DataTable({
        columns: [
          { data: gNameCol[gSTT_COL] },
          { data: gNameCol[gSTUDENT_COL] },
          { data: gNameCol[gSUBJECTS_COL] },
          { data: gNameCol[gGRADE_COL] },
          { data: gNameCol[gDATE_COL] },
          { data: gNameCol[gACTION_COL] },
        ],
        columnDefs: [
          {
            targets: gSTT_COL,
            class: "text-primary",
            render: function () {
              return gSTT++
            }
          },
          {
            targets: gSTUDENT_COL,
            class: "text-center",
            render: mappingStudent
          },
          {
            targets: gSUBJECTS_COL,
            class: "text-right text-success",
            render: mappingSubject
          },
          {
            targets: gACTION_COL,
            // class: "text-right text-success",
            defaultContent: ` <div class = "btn-group">
              <button class= "btn btn-success btn-edit"><i class="far fa-edit" title= "Edit" style=" cursor:pointer; "></i>&nbsp;Edit</button>
            <button class= "btn btn-danger btn-delete"><i class="far fa-edit" title= "Delete" style=" cursor:pointer; "></i>&nbsp;Delete</button>
              </div>
              
            `
          },
        ],
      });

      onPageLoading();
      getAllStudent(); // láy danh sách học sinh
      getAllSubject();// láy danh sách  môn học

      // gán sự kiện cho nút thêm mới 
      $("#btn-add-new").on("click", function () {
        onBtnAddNew();
      });
      // gán sự kiện cho nút Create trên modal 
      $("#btn-create").on("click", function () {
        onBtnCreateModal()
      })
      // gán sự kiện cho nút Edit 
      $("#student-table").on("click", ".btn-edit", function () {
        onBtnEditClick(this)
      })
      // gán sự kiện cho nút Update trên modal 
      $("#btn-update").on("click", function () {
        onBtnUpdateModal()
      })
      // gán sự kiện cho nút DElete 
      $("#student-table").on("click", ".btn-delete", function () {
        onBtnDeleteClick(this)
      })
      // gán sự kiện cho nút Delete trên modal 
      $("#btn-delete").on("click", function () {
        onBtnDeleteModal()
      })
      // gán sự kiện cho nút Lọc dữ liệu
      $("#btn-filter").on("click", function () {
        onBtnFilterClick()
      })

      function onPageLoading() {
        getAllGrade(); // hàm load danh sách điểm lên table
      }

      function onBtnAddNew() {
        $("#modal-create").modal("show")
      }

      function onBtnEditClick(paramButton) {
        //lưu thông tin Id đang dc edit vào biến toàn cục
        gID = getIdFromButton(paramButton)

        $.ajax({
          url: gBASE_URL + "/grades/" + gID,
          type: "GET",
          success: function (parammId) {
            showDataToUpdateModal(parammId);
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
      function onBtnDeleteClick(paramButton) {

        //lưu thông tin Id đang dc edit vào biến toàn cục
        gID = getIdFromButton(paramButton);
        $("#modal-delete").modal("show");

      }
      function onBtnCreateModal() {
        var vCreate = {
          studentId: 0,
          subjectId: 0,
          grade: 0,
          examDate: "",
        }

        getDataCreate(vCreate)
        var vIscheck = validateData(vCreate)
        if (vIscheck) {
          $.ajax({
            url: gBASE_URL + "/grades/",
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(vCreate),
            success: function (paramRes) {
              handleCreateSuccess()
            },
            error: function (paramErr) {
              console.log(paramErr.statusText)
            }

          })
        }
      }
      function onBtnUpdateModal() {
        var vUpdate = {
          studentId: 0,
          subjectId: 0,
          grade: 0,
          examDate: "",
        }

        getDataUpdate(vUpdate)
        var vIscheck = validateData(vUpdate)
        if (vIscheck) {
          $.ajax({
            url: gBASE_URL + "/grades/" + gID,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(vUpdate),
            success: function (paramRes) {
              handleUpdateSuccess()
            },
            error: function (paramErr) {
              console.log(paramErr.statusText)
            }

          })
        }
      }
      function onBtnDeleteModal() {
        $.ajax({
          url: gBASE_URL + "/grades/" + gID,
          type: "DELETE",
          success: function (parammId) {
            handleDeleteSuccess();
          },
          error: function (paramErr) {
            console.log(paramErr.status);
          }
        });
      }
      function onBtnFilterClick() {
        var vStudent = $("#select-student").val();
        var vSubject = $("#select-subject").val();
        var vDataFilter = gGrace.filter(function (paramData, index) {
          return (vStudent === "0" || vStudent === paramData.studentId)
            && (vSubject === "0" || vSubject === paramData.subjectId)
        });
        //gọi hàm load data vào table
        loadDataToTable(vDataFilter);


      }
      // hàm thu thập dữ liệu Create 
      function getDataCreate(paramCreate) {
        paramCreate.studentId = $("#select-student-create").val();
        paramCreate.subjectId = $("#select-subject-create").val();
        paramCreate.grade = $("#inp-grade-create").val();
        paramCreate.examDate = $("#inp-examDate-create").val();
      }
      // hàm thu thập dữ liệu Update 
      function getDataUpdate(paramUpdate) {
        paramUpdate.studentId = $("#select-student-update").val();
        paramUpdate.subjectId = $("#select-subject-update").val();
        paramUpdate.grade = $("#inp-grade-update").val();
        paramUpdate.examDate = $("#inp-examDate-update").val();
      }

      // hàm kiểm tra thông tin trên modal
      function validateData(paramCreate) {
        if (paramCreate.studentId == "") {
          alert("Hãy nhập Sutudent ID")
          return false
        }
        if (paramCreate.subjectId == "") {
          alert("Hãy nhập Subject ID")
          return false
        }
        if (paramCreate.grade == "") {
          alert("Hãy nhập Grade ")
          return false
        }
        if (!isFinite(paramCreate.grade)) {
          alert("Grade phải là số !")
          return false
        }
        if (paramCreate.examDate == "") {
          alert("Hãy nhập examDate")
          return false
        }

        return true
      }
      // h àm call API DANH SÁCH ĐIỂM 
      function getAllGrade() {
        $.ajax({
          url: gBASE_URL + "/grades",
          type: "GET",
          success: function (paramRes) {
            gGrace = paramRes
            loadDataToTable(gGrace)
            console.log(gGrace)
          },
          error: function (paramErr) {
            console.log(paramErr.status)
          }
        })
      }
      // hàm call API DANH SÁCH STUDENT
      function getAllStudent() {
        $.ajax({
          url: gBASE_URL + "/students",
          type: "GET",
          async: false,
          success: function (paramStudent) {
            gStudent = paramStudent
            handleStudentList(gStudent)
          },
          error: function (paramErr) {
            console.log(paramErr.status)
          }
        })
      }

      // call APi DANH SÁCH MÔN HỌC 
      function getAllSubject() {
        $.ajax({
          url: gBASE_URL + "/subjects",
          type: "GET",
          async: false,
          success: function (paramSubject) {
            gSubject = paramSubject
            handleSubjectList(gSubject)
          },
          error: function (paramErr) {
            console.log(paramErr.status)
          }
        })
      }
      //hàm tạo option cho select student
      function handleStudentList(paramStudent) {
        $.each(paramStudent, function (i, item) {
          $("#select-student").append($("<option>", {
            text: item.firstname + " " + item.lastname,
            value: item.id
          }));
          $("#select-student-create").append($("<option>", {
            text: item.firstname + " " + item.lastname,
            value: item.id
          }));
          $("#select-student-update").append($("<option>", {
            text: item.firstname + " " + item.lastname,
            value: item.id
          }));
        });
      }

      //hàm tạo option cho select subject
      function handleSubjectList(paramSubject) {
        $.each(paramSubject, function (i, item) {
          $("#select-subject").append($("<option>", {
            text: item.subjectName,
            value: item.id
          }));
          $("#select-subject-create").append($("<option>", {
            text: item.subjectName,
            value: item.id
          }));
          $("#select-subject-update").append($("<option>", {
            text: item.subjectName,
            value: item.id
          }));
        });
      }

      //hàm xử lý front-end khi add data thành công
      function handleCreateSuccess() {
        alert("Thêm mới bảng điểm thành công!");
        getAllGrade()
        // reset modal
        $("#select-student-create").val("0");
        $("#select-subject-create").val("0");
        $("#inp-grade-create").val();
        $("#inp-examDate-create").val();
        // ẩn modal
        $("#modal-create").modal("hide");
      }
      //hàm xử lý front-end khi Update data thành công
      function handleUpdateSuccess() {
        alert("update thành công!");
        getAllGrade()
        // ẩn modal
        $("#modal-update").modal("hide");
      }
      //hàm xử lý front-end khi DELETE data thành công
      function handleDeleteSuccess() {
        alert("delete thành công!");
        getAllGrade()
        // ẩn modal
        $("#modal-delete").modal("hide");
      }
      //hàm dựa vào button detail (edit or delete) xác định dc id data
      function getIdFromButton(paramButton) {
        var vTableRow = $(paramButton).closest("tr");
        var vRowData = gGradeTable.row(vTableRow).data();
        return vRowData.id;
      }
      //hàm show data lên update modal form
      function showDataToUpdateModal(paramDataObj) {
        console.log(paramDataObj)
        $("#select-student-update").val(paramDataObj.studentId);
        $("#select-subject-update").val(paramDataObj.subjectId);
        $("#inp-grade-update").val(paramDataObj.grade);
        $("#inp-examDate-update").val(paramDataObj.examDate);
        // hiển thị modal lên
        $("#modal-update").modal("show");
      }


      function loadDataToTable(paramData) {
        gSTT = 1
        gGradeTable.clear()
        gGradeTable.rows.add(paramData);
        gGradeTable.draw()
      }
    })
  </script>
</body>

</html>